SystemOrganization addCategory: #UIManager!
SystemOrganization addCategory: #'UIManager-Support'!

Object subclass: #UIManager
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'UIManager'!

!UIManager commentStamp: 'ar 12/27/2004 08:39' prior: 0!
UIManager is a dispatcher for various UI requests.!

UIManager subclass: #DummyUIManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UIManager'!

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
checkForNewDisplaySize

	Display extent = DisplayScreen actualScreenSize ifTrue: [^ self].
	DisplayScreen startUp.
! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseDirectory: label from: dir

	^ nil! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseFrom: aList lines: linesArray title: aString

	^ aList first! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
chooseFrom: labelList values: valueList lines: linesArray title: aString

	^ valueList first! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:23'!
confirm: queryString

	(ProvideAnswerNotification signal: queryString) ifNotNilDo: [:answer |
		^answer].

	self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:23'!
confirm: aString orCancel: cancelBlock

	(ProvideAnswerNotification signal: aString) ifNotNilDo: [:answer |
		^answer == #cancel ifTrue: [cancelBlock value] ifFalse: [answer]].

	self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock

	^ nil! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
edit: aText label: labelString accept: anAction

	^ nil! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
fileDoesNotExistsDefaultAction: anException
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
fileExistsDefaultAction: anException
! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:23'!
fontFromUser: priorFont

	self error: 'No user response possible'! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:24'!
inform: aString

! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:24'!
informUserDuring: aBlock

	aBlock value: [:string | ].! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
lowSpaceWatcherDefaultAction

	Transcript show: '*** LOW SPACE ***'; cr.
! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
newDisplayDepthNoRestore: pixelSize

	"Change depths.  Check if there is enough space!!  , di"
	| area need |
	pixelSize = Display depth ifTrue: [^ self  "no change"].
	pixelSize abs < Display depth ifFalse:
		["Make sure there is enough space"
		area := Display boundingBox area. "pixels"

		need := (area * (pixelSize abs - Display depth) // 8)  "new bytes needed"
				+ Smalltalk lowSpaceThreshold.
		(Smalltalk garbageCollectMost <= need
			and: [Smalltalk garbageCollect <= need])
			ifTrue: [self error: 'Insufficient free space']].
	Display setExtent: Display extent depth: pixelSize.

	DisplayScreen startUp! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:26'!
progressInitiationExceptionDefaultAction: anException

	| result |

	result := anException workBlock value: [:barVal | ].

	anException resume: result! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:23'!
request: queryString initialAnswer: defaultAnswer 

	^ defaultAnswer! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:18'!
request: queryString initialAnswer: defaultAnswer entryCompletion: anEntryCompletion

	^ defaultAnswer! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:20'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion

	^ defaultAnswer! !

!DummyUIManager methodsFor: 'ui requests' stamp: 'pavel.krivanek 5/31/2007 08:20'!
requestPassword: queryString
	
	^ self request: queryString initialAnswer: ''! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
restoreDisplay! !

!DummyUIManager methodsFor: 'display' stamp: 'pavel.krivanek 5/31/2007 08:20'!
restoreDisplayAfter: aBlock

	aBlock value.
	Sensor waitButton.! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/31/2007 08:20'!
syntaxErrorNotificationDefaultAction: anException

	Transcript show: '*** SYNTAX ERROR ***'; cr.
	Transcript show: anException; cr.
	Transcript show: (thisContext stack first: (20 min: thisContext stack size)); cr.
	anException return.! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek5/31/2007 08:20'!
unhandledErrorDefaultAction: anException

	Transcript show: '*** EXCEPTION ***'; cr.
	Transcript show: anException; cr.
	Transcript show: (thisContext stack first: (20 min: thisContext stack size)); cr.
	anException isResumable ifTrue: [ anException resume ]
! !

!DummyUIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 5/11/2008 17:44'!
warningDefaultAction: anException

	^ self unhandledErrorDefaultAction: anException! !

UIManager subclass: #NonInteractiveUIManager
	instanceVariableNames: 'uiManager doNotQuitOnRestart'
	classVariableNames: 'SnapshotImage'
	poolDictionaries: ''
	category: 'UIManager'!

!NonInteractiveUIManager commentStamp: 'IgorStasenko 1/24/2011 15:36' prior: 0!
This is a non-interactive UI manager, i.e. a UI manager which doesn't provides any kind of interactivity with users.

For most of requests, it throws an ErrorNonInteractive exception, which can be handled by various tools to do things differently when UI is not avaliable. For example:

response := [ UIManager default request: 'what is your name?' ] on: ErrorNonInteractive do: [:ex | ex resume: 'Mr. John Smith' ].

You can replace the default UI Manager with my instance in cases, when you need to guarantee that your task(s) will run in fully automated mode. This is useful for things like:
  - when image runs as a persistent application on a server
  - image runs headless from command-line with some batch scripts/commands

!

!NonInteractiveUIManager classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 1/25/2011 13:21'!
replacing: aUIManager

	"Replace the current UI manager with instance of myself. 
	Keep a backup reference to old manager, and then restore it, when image will be interactive again. "
	
	^ self new replacing: aUIManager! !

!NonInteractiveUIManager classSide methodsFor: 'settings' stamp: 'IgorStasenko 1/25/2011 13:20'!
snapshotErrorImage
	^ SnapshotImage == true! !

!NonInteractiveUIManager classSide methodsFor: 'settings' stamp: 'IgorStasenko 1/25/2011 13:20'!
snapshotErrorImage: aBool
	SnapshotImage := aBool! !

!NonInteractiveUIManager classSide methodsFor: 'settings' stamp: 'IgorStasenko 1/25/2011 13:19'!
uiSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #nonInteractive)
		label: 'Headless mode';
		with: [
			
			(aBuilder setting: #snapshotErrorImage)
				label: 'Make a snapshot of new version before quit' translated;
				target: NonInteractiveUIManager;
				description: 'On unhandled exception, save a new version of image before quit' translated.
		]! !

!NonInteractiveUIManager methodsFor: 'display' stamp: 'IgorStasenko 1/24/2011 14:34'!
checkForNewDisplaySize
	"do nothing"! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:13'!
chooseDirectory: label from: dir
	"Let the user choose a directory"
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:13'!
chooseFileMatching: patterns label: labelString
	"Let the user choose a file matching the given patterns"
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:14'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:14'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:15'!
chooseOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:15'!
confirm: queryString
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:16'!
confirm: queryString label: titleString
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:16'!
confirm: aString orCancel: cancelBlock
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:16'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 11:16'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice cancelChoice: cancelChoice default: aSymbol
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/25/2011 17:57'!
currentWorld

	" err.. we should probably prohibit this message.. but lets play nice"
	
	uiManager ifNotNil: [ ^ uiManager currentWorld ].
	
	ActiveWorld ifNotNil: [^ActiveWorld].
	^World! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:53'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^ProgressInitiationException 
		display: titleString
		at: aPoint 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:54'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/24/2011 10:33'!
fileDoesNotExistsDefaultAction: anException

	^ self nonInteractive: anException ! !

!NonInteractiveUIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/24/2011 14:37'!
fileExistsDefaultAction: anException

	^ self nonInteractive: anException ! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:54'!
fontFromUser: priorFont	
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'bitBlt' stamp: 'IgorStasenko 1/24/2011 18:34'!
grafPort	
	" yuck ... "
		
	^ Display defaultBitBltClass asGrafPort! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'md 1/25/2011 17:56'!
inform: aString

	"Just log notifications"
	(ProvideAnswerNotification signal: aString) ifNotNil: [:answer | ^true].
	
	Smalltalk logDuring: [:logger |
		logger 
			cr;
			nextPutAll: 'Notice: ';
			nextPutAll: aString;
			cr ].
	

		
	
	Transcript show: aString; cr.! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:56'!
informUserDuring: aBlock
	self
		displayProgress: ''
		at: 0@0
		from: 1 to: 100
		during: aBlock! !

!NonInteractiveUIManager methodsFor: 'initialize-release' stamp: 'IgorStasenko 1/25/2011 12:58'!
initialize
	doNotQuitOnRestart := false.! !

!NonInteractiveUIManager methodsFor: 'settings' stamp: 'IgorStasenko 1/24/2011 14:14'!
interactiveParserFor: requestor	
	
	^ false! !

!NonInteractiveUIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/25/2011 16:02'!
lowSpaceWatcherDefaultAction: preemptedProcess
	| ctx |
	"yeah.. space is low.. quit!!!! :)"
	
	
	ctx := preemptedProcess ifNotNil: [  preemptedProcess suspendedContext ].
	ctx ifNil: [ ctx := thisContext sender ]. 
	self quitFrom: ctx withMessage: 'Low space signal received.'.
	
	self halt. "what else we can do? "! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:57'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'display' stamp: 'IgorStasenko 1/24/2011 14:36'!
newDisplayDepthNoRestore: pixelSize	
	"do nothing"
	
! !

!NonInteractiveUIManager methodsFor: 'errors' stamp: 'IgorStasenko 1/21/2011 16:25'!
nonInteractive
	^ ErrorNonInteractive signal! !

!NonInteractiveUIManager methodsFor: 'errors' stamp: 'IgorStasenko 1/24/2011 10:34'!
nonInteractive: anException
	^ ErrorNonInteractive signalForException: anException! !

!NonInteractiveUIManager methodsFor: 'non-interactive' stamp: 'IgorStasenko 1/24/2011 16:33'!
nonInteractiveManager
	" Answer an instance of non-interactive manager, which will be used when image runs headless.
	  We put it here, so subclasses can override it. 
	
	We already non-interactive. Just answer self
	"! !

!NonInteractiveUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 14:33'!
onDebug: process context: context title: title full: bool

	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 14:32'!
onEventSensorStartup: anEventSensor

! !

!NonInteractiveUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 14:41'!
onPrimitiveError: aString	

	" log error and quit "
	^ self quitFrom: thisContext sender withMessage: aString! !

!NonInteractiveUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/25/2011 15:53'!
onSnapshot: resuming
	"The resuming argument is true when image boots from disk,
	and false, if user just did an image snapshot."
	
	"if we resuming and interactive, then restore original UI manager"
	
	resuming ifFalse: [
		
		" this flag set to true only if we saving a snapshot before quitting "
		doNotQuitOnRestart ifTrue: [
			Smalltalk snapshot: false andQuit: true
			]
		].
	(resuming and: [ Smalltalk isInteractive ]) ifTrue: [
		Default := uiManager.   "restore old, or nil, so it will be set in #default "
		UIManager default onSnapshot: resuming ]! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 18:39'!
progressInitiationExceptionDefaultAction: anException

	| result |

	result := anException workBlock value: [:barVal | ].

	anException resume: result! !

!NonInteractiveUIManager methodsFor: 'utils' stamp: 'IgorStasenko 1/25/2011 13:00'!
quit
	[
		self class snapshotErrorImage ifTrue: [
			doNotQuitOnRestart := true.
			"make a new image version snapshot before leaving"
			Smalltalk saveAsNewVersion  ].
	] ensure: [ 
		doNotQuitOnRestart ifFalse: [ Smalltalk snapshot: false andQuit: true ].
		doNotQuitOnRestart := false.	
	 ].
	
	! !

!NonInteractiveUIManager methodsFor: 'utils' stamp: 'IgorStasenko 1/25/2011 17:48'!
quitFrom: aContext withMessage: aString

	" log error and quit "
	[ Smalltalk 
		logError: aString
		inContext: aContext.
		
	" Print stacks of all current processes "

	Smalltalk logDuring: [:logger | 
		
		logger nextPutAll: 'Processes and their stacks: ';cr.
		
		Process allInstances do: [:each | | ctx |
		
			logger nextPutAll: 'Process: '; print: each; cr; nextPutAll: '  stack:'; cr; cr.
		
			ctx := each isActiveProcess ifTrue: [ thisContext sender ] ifFalse: [ each suspendedContext ].
			ctx ifNotNil: [
				(ctx stackOfSize: 20) do: [:s | logger print: s; cr ]].
			logger nextPutAll: '------------------------------'; cr; cr.	
		]].
	] ensure: [ self quit ]! !

!NonInteractiveUIManager methodsFor: 'utils' stamp: 'IgorStasenko 1/24/2011 16:41'!
replacing: aUIManager

	" save the aUIManager to restore it later, when we become interactive again "
	
	uiManager := aUIManager.
	
	self beDefault.! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:59'!
request: queryString initialAnswer: defaultAnswer 
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:58'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:58'!
request: queryString initialAnswer: defaultAnswer entryCompletion: anEntryCompletion
	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:59'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle
	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:59'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion
	^ self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/24/2011 13:59'!
requestPassword: queryString
	^self nonInteractive! !

!NonInteractiveUIManager methodsFor: 'display' stamp: 'IgorStasenko 1/24/2011 14:34'!
restoreDisplay	
	"do nothing"! !

!NonInteractiveUIManager methodsFor: 'display' stamp: 'IgorStasenko 1/24/2011 14:34'!
restoreDisplayAfter: aBlock	
	"do nothing"! !

!NonInteractiveUIManager methodsFor: 'ui requests' stamp: 'sig 1/25/2011 18:37'!
uiProcess

	^ uiManager ifNotNil: [ uiManager uiProcess ] ifNil: [ Project uiProcess ]! !

!NonInteractiveUIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/25/2011 13:05'!
unhandledErrorDefaultAction: anException

	self quitFrom: anException signalerContext  withMessage: anException description.
	
	UIManager default == self ifFalse: [
		^ UIManager default unhandledErrorDefaultAction: anException
		]! !

!NonInteractiveUIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/25/2011 13:09'!
warningDefaultAction: aWarning

	"Pass all warnings, but log them"
	
	Smalltalk logDuring: [:logger |
		logger 
			cr;
			nextPutAll: '*** Warning: ';
			nextPutAll: aWarning description;
			cr ].
	aWarning resume.

	! !

!UIManager class methodsFor: 'utils' stamp: 'nice 1/5/2010 15:59'!
createPageTestWorkspace
	"Used to generate a workspace window for testing page up and page down stuff."
	"self createPageTestWorkspace"

	| numberOfLines maxStringLength minLineCounterSize lineCounterSize offsetSize stream headerConstant prevStart prevStrLen prevLineNumber |
	numberOfLines := 400.
	maxStringLength := 22.
	minLineCounterSize := 3.
	lineCounterSize := (numberOfLines log asInteger + 1) max: minLineCounterSize.
	offsetSize := 5.
	stream := ReadWriteStream on: ''.
	headerConstant := lineCounterSize + 1 + offsetSize + 1.
	prevStart := headerConstant negated.
	prevStrLen := 0.
	prevLineNumber := 0.
	numberOfLines timesRepeat: [ | pad lineNumber stringLen start charIndex log |
		stringLen := maxStringLength atRandom max: 1.
		lineNumber := prevLineNumber + 1.
		start := prevStart + prevStrLen + headerConstant + 1.
		prevStart := start.
		prevStrLen := stringLen.
		prevLineNumber := lineNumber.
		log := lineNumber log asInteger.
		pad := lineCounterSize - log - 1.
		pad timesRepeat: [stream nextPutAll: '0'].
		stream nextPutAll: lineNumber printString.
		stream space.
		log := start log asInteger.
		pad := offsetSize - log - 1.
		pad timesRepeat: [stream nextPutAll: '0'].
		stream nextPutAll: start printString.
		stream space.
		charIndex := 'a' first asInteger.
		stringLen timesRepeat: [ | char |
			char := Character value: charIndex.
			charIndex := charIndex + 1.
			stream nextPut: char].
		lineNumber = numberOfLines ifFalse: [stream cr]
		].
	self default edit: stream contents label: 'Test Data'.
! !

!UIManager class methodsFor: 'initialization' stamp: 'IgorStasenko 1/24/2011 15:47'!
default
	| mgrClass |
	^Default ifNil:[
		"Note: The way the following is phrased ensures that you can always make 'more specific' managers merely by subclassing a tool builder and implementing a more specific way of reacting to #isActiveManager. For example, a BobsUIManager can subclass MorphicUIManager and will be considered before the parent (generic MorphicUIManager)."
		mgrClass := self allSubclasses 
			detect:[:any| any isActiveManager and:[
				any subclasses noneSatisfy:[:sub| sub isActiveManager]]] ifNone:[nil].
		mgrClass ifNotNil:[Default := mgrClass new]
	].! !

!UIManager class methodsFor: 'initialization' stamp: 'ar 12/27/2004 09:34'!
default: aUIManager
	Default := aUIManager! !

!UIManager class methodsFor: 'initialization' stamp: 'ar 2/11/2005 15:41'!
isActiveManager
	"Answer whether I should act as the active ui manager"
	^false! !

!UIManager methodsFor: 'private' stamp: 'IgorStasenko 1/24/2011 16:35'!
beDefault
	Default := self! !

!UIManager methodsFor: 'display' stamp: 'Pavel.Krivanek 10/28/2008 11:05'!
checkForNewDisplaySize	
	
	self subclassResponsibility ! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 19:35'!
chooseDirectory
	"Let the user choose a directory"
	^self chooseDirectoryFrom: FileDirectory default! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 19:36'!
chooseDirectory: label
	"Let the user choose a directory"
	^self chooseDirectory: label from: FileDirectory default! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 19:36'!
chooseDirectory: label from: dir
	"Let the user choose a directory"
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 19:36'!
chooseDirectoryFrom: dir
	"Let the user choose a directory"
	^self chooseDirectory: nil from: dir! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/17/2005 00:26'!
chooseFileMatching: patterns
	"Let the user choose a file matching the given patterns"
	^self chooseFileMatching: patterns label: nil! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/17/2005 00:26'!
chooseFileMatching: patterns label: labelString
	"Let the user choose a file matching the given patterns"
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 10:44'!
chooseFrom: aList
	"Choose an item from the given list. Answer the index of the selected item."
	^self chooseFrom: aList lines: #()! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 10:45'!
chooseFrom: aList lines: linesArray
	"Choose an item from the given list. Answer the index of the selected item."
	^self chooseFrom: aList lines: linesArray title: ''! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 09:37'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 10:44'!
chooseFrom: aList title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	^self chooseFrom: aList lines: #() title: aString! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/15/2005 23:42'!
chooseFrom: labelList values: valueList
	"Choose an item from the given list. Answer the selected item."
	^self chooseFrom: labelList values: valueList lines: #()! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/15/2005 23:43'!
chooseFrom: labelList values: valueList lines: linesArray
	"Choose an item from the given list. Answer the selected item."
	^self chooseFrom: labelList values: valueList lines: linesArray title: ''! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/15/2005 23:43'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/15/2005 23:43'!
chooseFrom: labelList values: valueList title: aString
	"Choose an item from the given list. Answer the selected item."
	^self chooseFrom: labelList values: valueList lines: #() title: aString! !

!UIManager methodsFor: 'ui requests' stamp: 'EstebanLorenzano 11/21/2009 17:01'!
chooseOrRequestFrom: aList title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	^self chooseOrRequestFrom: aList lines: #() title: aString! !

!UIManager methodsFor: 'ui requests' stamp: 'EstebanLorenzano 11/21/2009 10:48'!
chooseOrRequestFrom: labelList values: valueList lines: linesArray title: aString
	self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 08:39'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'jrd 5/12/2009 18:02'!
confirm: queryString label: titleString
	
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 09:49'!
confirm: aString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString. Answer true if  
	the response is yes, false if no. If cancel is chosen, evaluate  
	cancelBlock. This is a modal question--the user must respond yes or no."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'dc 1/10/2008 08:09'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	"Put up a yes/no menu with caption queryString. The actual wording for the two choices will be as provided in the trueChoice and falseChoice parameters. Answer true if the response is the true-choice, false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'GaryChambers 8/23/2010 12:11'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice cancelChoice: cancelChoice default: aSymbol
	"Put up a yes/no/cancel menu with caption queryString. The actual wording for the choices will be as provided in the trueChoice, falseChoice and cancelChoice parameters.
	Default should be one of #yes, #no or #cancel to set the default button.
	Answer true if the response is the true-choice, false if it's the false-choice, nil if the cancelChoice.
	This is a modal question -- the user must respond."
	
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 17:10'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 18:56'!
edit: aText
	"Open an editor on the given string/text"
	^self edit: aText label: nil! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 18:56'!
edit: aText label: labelString
	"Open an editor on the given string/text"
	^self edit: aText label: labelString accept: nil! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 18:56'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 4/15/2010 10:39'!
enterOrRequestFrom: aList title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	^self enterOrRequestFrom: aList lines: #() title: aString! !

!UIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 6/17/2010 09:23'!
fileDoesNotExistsDefaultAction: anException

	^ self subclassResponsibility ! !

!UIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 6/17/2010 09:19'!
fileExistsDefaultAction: anException

	^ self subclassResponsibility ! !

!UIManager methodsFor: 'ui requests' stamp: 'Pavel.Krivanek 10/28/2008 10:45'!
fontFromUser: priorFont	
	
	self subclassResponsibility! !

!UIManager methodsFor: 'bitBlt' stamp: 'Pavel.Krivanek 10/28/2008 11:02'!
grafPort	
	
	^ Display defaultBitBltClass current! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 08:46'!
inform: aString
	"Display a message for the user to read and then dismiss"
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 20:40'!
informUser: aString during: aBlock
	"Display a message above (or below if insufficient room) the cursor 
	during execution of the given block.
		UIManager default informUser: 'Just a sec!!' during: [(Delay forSeconds: 1) wait].
	"
	^self informUserDuring:[:bar| bar value: aString. aBlock value].! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 17:06'!
informUserDuring: aBlock
	"Display a message above (or below if insufficient room) the cursor 
	during execution of the given block.
		UIManager default informUserDuring:[:bar|
			#(one two three) do:[:info|
				bar value: info.
				(Delay forSeconds: 1) wait]]"
	^self subclassResponsibility! !

!UIManager methodsFor: 'settings' stamp: 'Pavel.Krivanek 10/28/2008 10:49'!
interactiveParserFor: requestor	
	
	^ false! !

!UIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 6/17/2010 09:27'!
lowSpaceWatcherDefaultAction: preemptedProcess! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 2/28/2005 17:05'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	^self subclassResponsibility! !

!UIManager methodsFor: 'display' stamp: 'Pavel.Krivanek 10/28/2008 11:05'!
newDisplayDepthNoRestore: pixelSize	
	
	self subclassResponsibility ! !

!UIManager methodsFor: 'non-interactive' stamp: 'IgorStasenko 1/24/2011 16:31'!
nonInteractiveManager
	" Answer an instance of non-interactive manager, which will be used when image runs headless.
	  We put it here, so subclasses can override it. "
	^ NonInteractiveUIManager replacing: self! !

!UIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:01'!
onDebug: process context: context title: title full: bool! !

!UIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:22'!
onEventSensorStartup: anEventSensor

! !

!UIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 6/17/2010 09:24'!
onFontsChanged

	! !

!UIManager methodsFor: 'events' stamp: 'Pavel.Krivanek 10/28/2008 11:01'!
onPrimitiveError: aString	! !

!UIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 15:56'!
onSnapshot: resuming

	"The resuming argument is true when image boots from disk,
	and false, if user just did an image snapshot."

	" do nothing by default "! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 08:41'!
request: queryString 
	"Create an instance of me whose question is queryString. Invoke it 
	centered at the cursor, and answer the string the user accepts. Answer 
	the empty string if the user cancels."
	^self request: queryString initialAnswer: ''! !

!UIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:18'!
request: queryString entryCompletion: anEntryCompletion
	"Create an instance of me whose question is queryString. Invoke it 
	centered at the cursor, and answer the string the user accepts. Answer 
	the empty string if the user cancels."
	^self request: queryString initialAnswer: '' entryCompletion: anEntryCompletion! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 08:41'!
request: queryString initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 2/13/2010 11:22'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	"Create an instance of me whose question is queryString with the given
	initial answer. Invoke it centered at the given point, and answer the
	string the user accepts. Answer the empty string if the user cancels."

	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/26/2010 10:18'!
request: queryString initialAnswer: defaultAnswer entryCompletion: anEntryCompletion
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 10/19/2010 16:30'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'AlainPlantec 11/25/2010 17:42'!
request: aStringOrText initialAnswer: defaultAnswer title: aTitle entryCompletion: anEntryCompletion
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."
	^self subclassResponsibility! !

!UIManager methodsFor: 'ui requests' stamp: 'ar 12/27/2004 08:47'!
requestPassword: queryString
	"Create an instance of me whose question is queryString. Invoke it centered
	at the cursor, and answer the string the user accepts. Answer the empty 
	string if the user cancels."
	^self subclassResponsibility! !

!UIManager methodsFor: 'display' stamp: 'Pavel.Krivanek 10/28/2008 11:05'!
restoreDisplay	
	
	self subclassResponsibility ! !

!UIManager methodsFor: 'display' stamp: 'Pavel.Krivanek 10/28/2008 11:05'!
restoreDisplayAfter: aBlock	
	
	self subclassResponsibility ! !

!UIManager methodsFor: 'default actions' stamp: 'pavel.krivanek 6/17/2010 09:25'!
syntaxErrorNotificationDefaultAction: anException

	^ self subclassResponsibility ! !

!UIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/25/2011 13:07'!
unhandledErrorDefaultAction: anException

	"Provide a default handling for unhandled error. 
	We should never reach this code, because it should be overridden by subclasses. 
	(but we can't put 'self subclassResponsibility' , because it will cause infinite loop,
	in case if current ui manager having no override of this method).
	This method is only for documentation purposes."
		
	Smalltalk snapshot: false andQuit: true.! !

!UIManager methodsFor: 'default actions' stamp: 'IgorStasenko 1/25/2011 13:07'!
warningDefaultAction: aWarning

	"Handle warning notification. Should be overidden by subclass"
	
	self subclassResponsibility  ! !

Exception subclass: #ProgressInitiationException
	instanceVariableNames: 'workBlock maxVal minVal aPoint progressTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UIManager-Support'!

!ProgressInitiationException commentStamp: '<historical>' prior: 0!
I provide a way to alter the behavior of the old-style progress notifier in String. See examples in:

ProgressInitiationException testWithout.
ProgressInitiationException testWith.
!

!ProgressInitiationException class methodsFor: 'signalling' stamp: 'ajh 1/22/2003 23:51'!
display: aString at: aPoint from: minVal to: maxVal during: workBlock

	^ self new
		display: aString at: aPoint from: minVal to: maxVal during: workBlock! !

!ProgressInitiationException class methodsFor: 'examples and tests' stamp: 'RAA 5/15/2000 15:46'!
testInnermost

	"test the progress code WITHOUT special handling"

	^'Now here''s some Real Progress'
		displayProgressAt: Sensor cursorPoint
		from: 0 
		to: 10
		during: [ :bar |
			1 to: 10 do: [ :x | 
				bar value: x. (Delay forMilliseconds: 500) wait.
				x = 5 ifTrue: [1/0].	"just to make life interesting"
			].
			'done'
		].

! !

!ProgressInitiationException class methodsFor: 'examples and tests' stamp: 'RAA 5/15/2000 12:42'!
testWith

	"test progress code WITH special handling of progress notifications"

	^[ self testWithAdditionalInfo ] 
		on: ProgressInitiationException
		do: [ :ex | 
			ex sendNotificationsTo: [ :min :max :curr |
				Transcript show: min printString,'  ',max printString,'  ',curr printString; cr
			].
		].
! !

!ProgressInitiationException class methodsFor: 'examples and tests' stamp: 'RAA 5/15/2000 12:04'!
testWithAdditionalInfo

	^{'starting'. self testWithout. 'really!!'}! !

!ProgressInitiationException class methodsFor: 'examples and tests' stamp: 'RAA 5/15/2000 15:45'!
testWithout

	"test the progress code WITHOUT special handling"

	^[self testInnermost]
		on: ZeroDivide
		do: [ :ex | ex resume]

! !

!ProgressInitiationException methodsFor: 'as yet unclassified' stamp: 'pavel.krivanek 6/17/2010 10:00'!
defaultAction

	^ UIManager default progressInitiationExceptionDefaultAction: self! !

!ProgressInitiationException methodsFor: 'as yet unclassified' stamp: 'RAA 5/15/2000 11:43'!
display: argString at: argPoint from: argMinVal to: argMaxVal during: argWorkBlock

	progressTitle := argString.
	aPoint := argPoint.
	minVal := argMinVal.
	maxVal := argMaxVal.
	workBlock := argWorkBlock.
	^self signal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:06'!
maxVal
	^maxVal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:06'!
minVal
	^minVal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:05'!
point
	^aPoint! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:04'!
progressTitle
	^progressTitle! !

!ProgressInitiationException methodsFor: 'as yet unclassified' stamp: 'RAA 5/15/2000 12:40'!
sendNotificationsTo: aNewBlock

	self resume: (
		workBlock value: [ :barVal |
			aNewBlock value: minVal value: maxVal value: barVal
		]
	)
! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'pavel.krivanek 9/28/2006 20:31'!
workBlock 
	
	^ workBlock! !

!String methodsFor: '*UIManager-Support' stamp: 'yo 11/3/2004 19:24'!
displayProgressAt: aPoint from: minVal to: maxVal during: workBlock 
	"Display this string as a caption over a progress bar while workBlock is evaluated.

EXAMPLE (Select next 6 lines and Do It)
'Now here''s some Real Progress'
	displayProgressAt: Sensor cursorPoint
	from: 0 to: 10
	during: [:bar |
	1 to: 10 do: [:x | bar value: x.
			(Delay forMilliseconds: 500) wait]].

HOW IT WORKS (Try this in any other language :-)
Since your code (the last 2 lines in the above example) is in a block,
this method gets control to display its heading before, and clean up 
the screen after, its execution.
The key, though, is that the block is supplied with an argument,
named 'bar' in the example, which will update the bar image every 
it is sent the message value: x, where x is in the from:to: range.
"
	^ProgressInitiationException 
		display: self
		at: aPoint 
		from: minVal 
		to: maxVal 
		during: workBlock! !

Notification subclass: #ProgressNotification
	instanceVariableNames: 'amount done extra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UIManager-Support'!

!ProgressNotification commentStamp: '<historical>' prior: 0!
Used to signal progress without requiring a specific receiver to notify. Caller/callee convention could be to simply count the number of signals caught or to pass more substantive information with #signal:.!

!ProgressNotification class methodsFor: 'exceptioninstantiator' stamp: 'ajh 1/22/2003 23:51'!
signal: signalerText extra: extraParam
	"TFEI - Signal the occurrence of an exceptional condition with a specified textual description."

	| ex |
	ex := self new.
	ex extraParam: extraParam.
	^ex signal: signalerText! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:11'!
amount
	^amount! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:12'!
amount: aNumber
	amount := aNumber! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:11'!
done
	^done! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:12'!
done: aNumber
	done := aNumber! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:12'!
extraParam
	^extra! !

!ProgressNotification methodsFor: 'accessing' stamp: 'ar 3/2/2001 20:12'!
extraParam: anObject
	extra := anObject! !

Notification subclass: #ProvideAnswerNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UIManager-Support'!

!ClassBuilder class methodsFor: '*UIManager' stamp: 'sd 3/28/2008 11:03'!
checkClassHierarchyConsistency
	"Check the consistency of the class hierarchy. The class hierarchy is consistent if the following
	two logical equivalences hold for classes A and B:
	- B is obsolete and 'B superclass' yields A  <-->  'A obsoleteSubclasses' contains B
	- B is not obsolete and 'B superclass' yields A  <-->  'A subclasses' contains B"
	UIManager default informUserDuring: [ :bar | self checkClassHierarchyConsistency: bar ]! !

!ClassBuilder class methodsFor: '*UIManager' stamp: 'sd 3/28/2008 11:03'!
cleanupAndCheckClassHierarchy
	"Makes the class hierarchy consistent and removes obsolete classes from the SystemDictionary.
	Afterwards it checks whether the hierarchy is really consistent."
	UIManager default informUserDuring: [ :bar | self cleanupAndCheckClassHierarchy: bar ]! !

!ClassBuilder class methodsFor: '*UIManager' stamp: 'sd 3/28/2008 11:03'!
cleanupClassHierarchy
	"Makes the class hierarchy consistent and removes obsolete classes from the SystemDictionary."
	UIManager default informUserDuring: [ :bar | self cleanupClassHierarchy: bar ]! !

!ClassBuilder methodsFor: '*UIManager' stamp: 'sd 3/28/2008 11:03'!
informUserDuring: aBlock 
	self class isSilent ifTrue: [ ^ aBlock value ].
	UIManager default informUserDuring: 
		[ :bar | 
		progress := bar.
		aBlock value ].
	progress := nil! !

!UnhandledError methodsFor: '*UIManager' stamp: 'pavel.krivanek 7/4/2010 16:38'!
defaultAction

 	^ UIManager default unhandledErrorDefaultAction: self exception! !

Error subclass: #ErrorNonInteractive
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UIManager'!

!ErrorNonInteractive commentStamp: 'IgorStasenko 1/25/2011 13:29' prior: 0!
This error thrown when image runs in non-interactive mode (no user intervention possible nor expected),
but application trying to use tools which require user's intervention.
For example, in headless image application trying to query a user name, or dialog to confirm with proceeding some action.!

!ErrorNonInteractive classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/24/2011 10:34'!
signalForException: anError

	^ self new
		exception: anError;
		signal! !

!ErrorNonInteractive methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/24/2011 14:42'!
defaultAction
	" log error and quit "
	
	^ UIManager default quitFrom: self signalerContext withMessage: self description! !

!ErrorNonInteractive methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/24/2011 14:43'!
description
	^ 'An attempt to use interactive tools detected, while in non-interactive mode'! !

!ErrorNonInteractive methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/24/2011 10:36'!
exception

	^ exception! !

!ErrorNonInteractive methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/24/2011 10:36'!
exception: anError

	exception := anError! !
